OpenShot Audio Library | OpenShotAudio: juce::HighResolutionTimer Class Reference

OpenShot Audio Library | OpenShotAudio 1.0.0

Loading...
Searching...
No Matches
juce::HighResolutionTimer Class Referenceabstract

`#include <juce_HighResolutionTimer.h>`

## Public Member Functions
virtual | ~HighResolutionTimer ()
virtual void | hiResTimerCallback ()=0
void | startTimer (int intervalInMilliseconds)
void | stopTimer ()
bool | isTimerRunning () const noexcept
int | getTimerInterval () const noexcept

## Protected Member Functions
| HighResolutionTimer ()

## Detailed Description

A high-resolution periodic timer.

This provides accurately-timed regular callbacks. Unlike the normal Timer class, this one uses a dedicated thread, not the message thread, so is far more stable and precise.

You should only use this class in situations where you really need accuracy, because unlike the normal Timer class, which is very lightweight and cheap the HighResolutionTimer will use far more resources and require thread safety considerations.

See also
  Timer

Definition at line 42 of file juce_HighResolutionTimer.h.

## Constructor & Destructor Documentation

## ◆ HighResolutionTimer()

juce::HighResolutionTimer::HighResolutionTimer | ( |  | ) |
| protected

Creates a HighResolutionTimer. When created, the timer is stopped, so use startTimer() to get it going.

Definition at line 107 of file juce_HighResolutionTimer.cpp.

Referenced by hiResTimerCallback().

## ◆ ~HighResolutionTimer()

juce::HighResolutionTimer::~HighResolutionTimer | ( |  | ) |
| virtual

Destructor.

Definition at line 110 of file juce_HighResolutionTimer.cpp.

## Member Function Documentation

## ◆ getTimerInterval()

int juce::HighResolutionTimer::getTimerInterval | ( |  | ) | const
| noexcept

Returns the timer's interval.

Returns
  the timer's interval in milliseconds if it's running, or 0 if it's not.

Definition at line 128 of file juce_HighResolutionTimer.cpp.

Referenced by hiResTimerCallback().

## ◆ hiResTimerCallback()

virtual void juce::HighResolutionTimer::hiResTimerCallback | ( |  | ) |
| pure virtual

The user-defined callback routine that actually gets called periodically.

This will be called on a dedicated timer thread, so make sure your implementation is thread-safe!

On some platforms the dedicated timer thread may be shared with other HighResolutionTimer's so aim to complete any work in this callback as fast as possible.

It's perfectly ok to call startTimer() or stopTimer() from within this callback to change the subsequent intervals. However, if you call stopTimer() in the callback it's still best practice to call stopTimer() from the destructor in order to avoid data races.

## ◆ isTimerRunning()

bool juce::HighResolutionTimer::isTimerRunning | ( |  | ) | const
| noexcept

Checks if the timer has been started.

Returns
  true if the timer is running.

Definition at line 133 of file juce_HighResolutionTimer.cpp.

Referenced by hiResTimerCallback(), and ~HighResolutionTimer().

## ◆ startTimer()

void juce::HighResolutionTimer::startTimer | ( | int | intervalInMilliseconds | ) |

Starts the timer and sets the length of interval required.

If the timer has already started, this will reset the timer, so the time between calling this method and the next timer callback will not be less than the interval length passed in.

In exceptional circumstances the dedicated timer thread may not start, if this is a potential concern for your use case, you can call isTimerRunning() to confirm if the timer actually started.

Parameters

  intervalInMilliseconds | the interval to use (a value of zero or less will stop the timer)

Definition at line 118 of file juce_HighResolutionTimer.cpp.

Referenced by hiResTimerCallback().

## ◆ stopTimer()

void juce::HighResolutionTimer::stopTimer | ( |  | ) |

Stops the timer.

This method may block while it waits for pending callbacks to complete. Once it returns, no more callbacks will be made. If it is called from the timer's own thread, it will cancel the timer after the current callback returns.

To prevent data races it's normally best practice to call this in the derived classes destructor, even if stopTimer() was called in the hiResTimerCallback().

Definition at line 123 of file juce_HighResolutionTimer.cpp.

Referenced by hiResTimerCallback(), and ~HighResolutionTimer().

The documentation for this class was generated from the following files:

- juce_HighResolutionTimer.h
- juce_HighResolutionTimer.cpp